﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;

using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private DataSet ds1;
		public MainWindow()
		{

            System.Diagnostics.Debug.WriteLine("MainWindow  Before InitializeComponents");
			InitializeComponent();
            System.Diagnostics.Debug.WriteLine("MainWindow  After InitializeComponents");
			xamDataGrid1.RecordsInViewChanged += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordsInViewChangedEventArgs>(xamDataGrid1_RecordsInViewChanged);
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            xamDataGrid1.Loaded += new RoutedEventHandler(xamDataGrid1_Loaded);
            xamDataGrid1.DataContextChanged += new DependencyPropertyChangedEventHandler(xamDataGrid1_DataContextChanged);
            xamDataGrid1.FieldLayoutInitializing += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs>(xamDataGrid1_FieldLayoutInitializing);
            xamDataGrid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(xamDataGrid1_FieldLayoutInitialized);
            xamDataGrid1.Initialized += new EventHandler(xamDataGrid1_Initialized);
            xamDataGrid1.LayoutUpdated += new EventHandler(xamDataGrid1_LayoutUpdated);

            xamDataGrid1.SourceUpdated += new EventHandler<DataTransferEventArgs>(xamDataGrid1_SourceUpdated);
        }

        void xamDataGrid1_SourceUpdated(object sender, DataTransferEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_SourceUpdated");
        }

        void xamDataGrid1_LayoutUpdated(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_LayoutUpdated");
        }

        void xamDataGrid1_Initialized(object sender, EventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_Initialized");
        }

        void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_FieldLayoutInitialized");

            for (int i = 0; i < xamDataGrid1.FieldLayouts[0].Fields.Count; i++)
            {
                System.Diagnostics.Debug.WriteLine(xamDataGrid1.FieldLayouts[0].Fields[i].Name);
            }

        }

        void xamDataGrid1_FieldLayoutInitializing(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_FieldLayoutInitializing");
            for (int i = 0; i < xamDataGrid1.FieldLayouts[0].Fields.Count; i++)
            {
                System.Diagnostics.Debug.WriteLine(xamDataGrid1.FieldLayouts[0].Fields[i].Name);
            }
        }

        void xamDataGrid1_DataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_DataContextChanged");
        }

        void xamDataGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("xamDataGrid1_Loaded");
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine("MainWindow_Loaded");
        }

		void xamDataGrid1_RecordsInViewChanged(object sender, Infragistics.Windows.DataPresenter.Events.RecordsInViewChangedEventArgs e)
		{
            //This is the only event in which we are able to set back color for the cells in the grid.
            //Here a specific row is always highlighted. but our application requires the rows to be highlighted to be calculated dynamically.

           Record[] recs =  xamDataGrid1.GetRecordsInView(false);
            for (int r = 0; r < recs.Length - 1; r++)
            {

                DataRecord dr = recs[r] as DataRecord;

                for (int i = 0; i < dr.Cells.Count; i++)
                {
                    CellValuePresenter cellValPresenter = CellValuePresenter.FromCell(dr.Cells[i]);
                    if (cellValPresenter != null)
                    {
                        if (r==0)
                            cellValPresenter.Background = Brushes.Blue;
                        else
                            cellValPresenter.Background = Brushes.White;
                    }
                }
            }
		}

		protected override void OnInitialized(EventArgs e) 
		{

            System.Diagnostics.Debug.WriteLine("OnInitialize");

			base.OnInitialized(e);
			ds1 = new DataSet();
			DataTable dt = new DataTable();
			ds1.Tables.Add(dt);
			DataColumn cl = new DataColumn("Col1", typeof(Int16));

			dt.Columns.Add(cl);
			DataColumn c2 = new DataColumn("Col2", typeof(Int16));

			dt.Columns.Add(c2);
			DataColumn c3 = new DataColumn("Col3", typeof(Int16));
			dt.Columns.Add(c3);
			DataColumn c4 = new DataColumn("Col4", typeof(Int16));
			dt.Columns.Add(c4);

			DataColumn c5 = new DataColumn("Col5", typeof(Int16));
			dt.Columns.Add(c5);

			for (int i = 0; i < 20; i++)
			{
				DataRow rw = dt.NewRow();
				dt.Rows.Add(rw);
				rw["Col1"] = i;
				rw["Col2"] = i;
				rw["Col3"] = i;
				rw["Col4"] = i;
				rw["Col5"] = i;
			}
		}

		private void btn1_Click(object sender, RoutedEventArgs e)
		{

            System.Diagnostics.Debug.WriteLine("btn1_Click");
			xamDataGrid1.DataSource = ds1.Tables[0].DefaultView;         


		}
	}
}
